﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Public Class camera
    Public position As Vector2
    Public viewmatrix As Matrix
    Dim _Width As Integer
    Dim _Height As Integer
    Dim _zoom As Single
    Dim _rotation As Single

    Public Property Zoom() As Single
        Get
            Return _zoom
        End Get
        Set(value As Single)
            _zoom = value
            'to avoid negative zoom / image flip
            If _zoom < 0.1F Then _zoom = 0.1F
        End Set
    End Property
    Public Property Rotation() As Single
        Get
            Return _rotation
        End Get
        Set(value As Single)
            _rotation = value
        End Set
    End Property
    Public Sub New(viewport As viewport)
        _Width = viewport.Width
        _Height = viewport.Height
        _zoom = 1
        _rotation = 0
    End Sub

    Public Sub setfocalpoint(focalposition As Vector2)
        position = New Vector2(focalposition.X - _Width / 2, focalposition.Y - _Height / 2)
        If position.X < 0 Then position.X = 0
        If position.Y < 0 Then position.Y = 0
    End Sub

    Public Sub setfocalpoint(ByVal focalposition As Vector2, ByVal lock As Vector2)
        If focalposition.X > lock.X Then focalposition.X = lock.X
        If focalposition.Y > lock.Y Then focalposition.Y = lock.Y

        position = New Vector2(focalposition.X - _Width / 2, focalposition.Y - _Height / 2)

        If position.X < 0 Then position.X = 0
        If position.Y < 0 Then position.Y = 0
    End Sub

    Public Sub update()
        'no rotation / no zoom
        'viewmatrix = Matrix.CreateTranslation(New Vector3(-position, 0))

        'with rotation and zoom
        viewmatrix = Matrix.CreateTranslation(New Vector3(-position, 0)) * Matrix.CreateRotationZ(_rotation) * Matrix.CreateScale(New Vector3(_zoom, _zoom, 1))
    End Sub
End Class